;
(setq VERS "1.0")
;
;============================
; block-atttribute edit lisp
;copyright october 20, 1992, Caldera Software - r j zimmer
;
;This software may be used only in accordance with the licensing agreement.
;Please respect the creative endeavors of those of us who bring you these tools.
;
;
(princ (strcat "\n\t BLOKPOWR.lsp copyright by CALDERA SOFTWARE v" VERS ))
;
;======================================
(setq doit T)
;===========================================
(defun c:BLOKPOWR ()
  (setvar "CMDECHO" 0)
(if DOIT
 (progn
 (setq DONE nil)
   (while (not DONE)
    (initget "Block Attribute")
    (if  (setq BorA (getkword "\nEdit Block or Attribute - (Press RETURN to quit) "))
         (OPTIONS)
	 (setq DONE "T")
    );end if
   );end while
 );end progn
    (princ "\n ERROR ERROR -  Support programs NOT FOUND! CANNOT continue!")
);end if
(princ)
);end defun B-A -----------------------
;
;

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 (prompt "\nLoading ATTRIBUTE Utilites for the Block-Attribute Editor. Please wait.. ")

;AFIX LISP
;
; copyright by CALDERA SOFTWARE, march 1,1993
; Corvallis, Oregon 97330
; r j zimmer
;
;This is a number of routines that operate
; on attributes of block insertion.
;
;AGUMENTS	>ATTR	:attribute name
;		>AVAL :new value for the attribute characteristic
;RETURNS	>	
;
;
;================================================
;

; FINDS block for ATTRIBUTE  revision :
(defun AFIX (BLKDAT)
   (setq DONE nil BLK (FLLD -1 BLKDAT) ATCNT (+ 1 ATCNT))
      (if  (= (FLLD 66 BLKDAT) 1)	;THE BLOCK has attributes.
          (progn
	     (setq AT (entnext BLK) ATDAT (entget AT))	;get the blocks' subentity name
             						;get the subentity's data
             (setq LOOP T)
             (while LOOP
                (cond 
		   ((and (= (FLLD 0 ATDAT) "ATTRIB") (= (FLLD 2 ATDAT) ATTR));end and
			 (cond
				((= ATTCHR 40)
				  (setq ATDAT (subst (cons 40 AVAL) (assoc 40 ATDAT) ATDAT)) ;new attribute HEIGHT
				)
				((= ATTCHR 8)
				  (setq ATDAT (subst (cons 8 AVAL) (assoc 8 ATDAT) ATDAT)) ;new attribute LAYER
				)
				((= ATTCHR 10)
				  (setq AVAL (SHFTMOD))
				  (setq ATDAT (subst (cons 10 AVAL) (assoc 10 ATDAT) ATDAT)) ;new attribute POSITION
				)
				((= ATTCHR 7)
				  (setq ATDAT (subst (cons 7 AVAL) (assoc 7 ATDAT) ATDAT)) ;new attribute STYLE
				)
				((= ATTCHR 1)
				  (setq ATDAT (subst (cons 1 AVAL) (assoc 1 ATDAT) ATDAT)) ;new attribute VALUE
				)
				((= ATTCHR 70)
				  (setq ATDAT (subst (cons 70 AVAL) (assoc 70 ATDAT) ATDAT)) ;new attribute VISIBILIT
				)
			 );end cond
                	 (entmod ATDAT)
        	         (entupd AT)
        		 (princ ".")
			 (setq #ATTS (+ 1 #ATTS))
	       		 (setq LOOP nil)	
		   );end 1st cond
		   ((and (= (FLLD 0 ATDAT) "ATTRIB") (/= (FLLD 2 ATDAT) ATTR));end and
		     (setq AT (entnext AT) ATDAT (entget AT))	;get the blocks' NEXT 
								;subentity name & data
		   );end 2nd cond
                   ((= (FLLD 0 ATDAT) "SEQEND")
                       (setq LOOP nil)
		   );  - stop scan
                   (T  
		     (setq AT (entnext AT) ATDAT (entget AT))	;go to NEXT subent anyway
		   )
		);end cond
             );end while
          );end progn
      );end if
 (princ)
);end defun afix  *********************************
;================================================
;-----------------------
;SHFTMOD
;
;This routine SHFT entities of a selection set
; by MODifying their INSERTIONr group codes :
;	code 10 for the X,Y insertion point
; It take as ARGUMENTS : Entity name
;			 SHFT Factor
;  X=Y & X\=Y ARE both valid
;
; It returns nil
;
(defun SHFTMOD ()
   (setq 
	OLDPT (cdr (assoc 10 ATDAT))
	NEWPT (list
		(+ DX (car OLDPT));add delta X shift to point.
		(+ DY (cAdr OLDPT));add delta Y shift to point.
		(cAddr OLDPT); Preserve the Z coordinate.
	       );end list
   );end setq
);end SHFTMOD ===========================
;

;
;SHFT-ATT
; shifts an entity a delta X, delta Y, delta Z
;
;ARGUMENTS	>TARG	:entity name
;		>DX	:delta X
;		>DY	:delta Y
;		>DZ	:delta Z
;
;RETURNS	>NEW INSERTION POINT
;
(defun SHFT-ATT (/ DX DY)
   (setq 
	NEWX (+ (cdr (assoc 10 ATDAT)) DX);add x shift factor to "X" of insertion point
	NEWY (+ (cdr (assoc 10 ATDAT)) DY);add Y shift factor to "Y" of insertion point
;	NEWZ (+ (cdr (assoc 10 ATDAT)) DZ);add Z shift factor to "Z" of insertion point
   );end setq
(SHFTMOD)
);end defun SHFT-ATT==========================================
;

;------------------------
;ATTLIST 
;copyright by 
;		r j zimmer
;		JANUARY 27,1993
;		Caldera Software
;		Corvallis, Oregon 97330
;
;This routine LISTS all attribut tags associated with a block insertion.
; ARGUMENTS  : NONE
; RETURNS    : the attribute tag (as a string) or "nil" 
; FUNCTIONS  : PLUCK
:		ENDAT
;
;
(defun ATTLIST ()
 (if BNM
  (progn
  (if (or (not ATTR) (/= OLDBLK BNM))
   (progn		;GET LIST OF ATTRIBUTES----
     (setq ATTNM nil)
     (setq ENTd (tblsearch "BLOCK" BNM))
     (if ENTd
   	(progn			;step through the list of attribute tags
	   (setq ATTLST nil)				; start with a fresh (empty) list of attribute TAGs.
	   (setq Enam (pluck -2 ENTd));; get first subentity entity name
	   (if (= "ATTDEF" (pluck 0 (setq ED (entget Enam))))			; if the subentity is an attribute
	      (setq ATTLST (append ATTLST (list (setq att (pluck 2 ED))))); add the TAG to the tag list
	   );end if 		;continue thru whole subent list
	   (while (not
		     (= nil (setq Enam (entnext ENAM))) ; get next subentity entity name
		  );end not
	      (if (= "ATTDEF" (pluck 0 (setq ED (entget Enam))))		; if the subentity is an attribute
		         (setq ATTLST (append ATTLST (list (pluck 2 ED)))); add the TAG to the tag list
	      );end if
	   );end while
	);end progn
     );end if ENTd
   );end progn
    );end if
    (if ATTLST		;GET THE NAME OF THE ATTRIBUTE TO USE ----
	(progn
          (textpage)
	  (prompt "\nThe BLOCK you picked has the following ATTRIBUTE tags:")
 	  (foreach n ATTLST (princ "\n\t| ") (princ n))
	  (if ATTNM
	     (setq ATTPRMT (strcat "\nWhich one do you want to edit <" ATTNM ">: " )
		NEXTATT (getstring ATTPRMT)
	     );end setq
	     (setq ATTPRMT "\nWhich one do you want to edit : " 
		NEXTATT (getstring ATTPRMT)
	     );end setq
	  );end if
	  (if (/= NEXTATT "") (setq ATTNM (strcase NEXTATT)))
    	  (while (not (member ATTNM ATTLST))
	     (prompt "\n OOPS ! -> ")
	     (princ ATTNM)
	     (prompt " is not on the list !")
	     (setq ATTNM (getstring "\nPlease retype that. "))
	   );end while
	   (setq ATTNM ATTNM)
	   (princ "\n\tUsing the Attribute ")
	);end progn
	(prompt "\n Block has no Attributes !")
    );end if ATTLST
  );end progn
 );end if BNM 
 ATTNM
);end defun ATTLIST =============================
;
;ASUBOPT
; attribute SUB OPTIONS
;
; this module collects more SUBoptions based on previous choices.
; 
;it takes a STRING as an argument and prompts for the attribute name
; it returns a new value for the attribute insertion name:
; & the modification value.
;
; if the attribute is not a valid insert an error message is echoed
; & the routine returns nil
; 
(defun ASubOPT (Bin)
    (progn 
      (cond
	((= BIN "siZe")
	   (setq ATTCHR 40)
	   (setq AVAL (getreal "Enter text siZe for these attributes : "))
	)
	((= BIN "Layer")
	   (setq ATTCHR 8)
	   (setq OK T)
	   (while OK
	      (setq AVAL (getstring "Enter Layer for these attributes : "))
	      (if (tblsearch "layer" AVAL)
		   (setq OK nil); you're done - get out
		   (princ (strcat "\n ERROR - Layer " AVAL " not found! Try again please."))
	      );end if
	   );end while
	)
	((= BIN "sHift")
	   (setq ATTCHR 10)
 	   (initget (+ 1))
	   (setq dX (getreal "\n Enter delta X to shift the selected attributes : ")
	         dY (getreal "\n Enter delta Y to shift the selected attributes <dX=dY> : ")	
	   )
	   (if (= dY nil)(setq dY dX)); dX=DY
	)
	((= BIN "sTyle")
	   (setq ATTCHR 7)
	   (setq OK T)
	   (while OK
	      (setq AVAL (getstring "Enter text STYLE for these attributes : "))
	      (if (tblsearch "style" AVAL)
		   (setq OK nil); you're done - get out
		   (princ (strcat "\n ERROR - Style " AVAL " not found! Try again please."))
	      );end if
	   );end while
	)
	((= BIN "Value")
	   (setq ATTCHR 1)
	   (setq AVAL (getstring T "Enter new Value for ALL these attributes : "))
	)
	((= BIN "visiBility")
	   (setq ATTCHR 70)
	   (INITGET "0 1" 1)
	   (setq AVAL (atoi (getkword "Set visibility ON or OFF ? (enter 0 for ON, 1 for OFF) : ")))
	)
      );end cond
    );end progn
);end defun ASubOPT==============================
;
;------------------AOPTS---------------
;attribute options
;
;
(defun aoptS ()
	(if (not aprev) (setq aprev " "))
	(initget "siZe Layer sTyle Value visiBility")
	(prompt "\nSelect ATTRIBUTE characteristic to edit :")
	(prompt (strcat "\n\t siZe, Layer, sTyle, Value, visiBility : <" aprev ">  "))
	(setq AOPT (getkword))
	(if AOPT (setq APREV AOPT)(SETQ AOPT APREV))
);end defun aopts================================

;HAS-ATTS.lsp
;
;This routine checks to see if the 
;supplied block definition has ATTRIBUTES.
;
;ARGUMENTS:	block name
;RETURNS:	NONnil or nil
;
(defun HAS-ATTS (BLK2CHK)
 (setq HASEM nil)
 (if (= 66 (cdr (assoc 70 (tblsearch "block" BLK2CHK))))
   (setq HASEM "T")
 );end if	
);end defun HAS_ATTS


;=========================================================================
(prompt "\n\tCopyright Caldera Software April 16, 1993, Corvallis, Oregon USA. ")
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; This is a set of utilities that are 
; required for the BLOCK & ATTRIBUTE fix program to work.
;
(prompt "\nLoading BLOCK Utilites for the Block-Attribute Editor. Please wait.. ")

;
;------------------ALLSETS-------------
;ALLSET
;
;This routine obtains a selection set of ALL of the
; entites in the drawing database that satisfy the filterlist.
;
;ARGUMENTS: BNAM, a string (block's name)
;RETURNS: selection set of entities
(defun ALLSET (BNAM)
   (setq LST '(0 . "insert") 
	 BLST (cons 2 BNAM)
	 FLTLST (append (list LST) (list BLST))
   	 BSET (ssget "X" FLTLST)
   );end setq
);end defun ALLSET===============================
;
;------------------ASKBNM--------------
;THIS ROUTINE prompts for a Block insert's name & offers a chance to "pick" one 
;to get the name.
; If the pick option is selected this routine calls the next PKBLKNM.
;
;ARGUMENTS:	none
;RETURNS:	blockname (string)
;
;
;------------------ASKBNM-------------
;copyright by
;	r j zimmer
;	january 27,1993
;	Caldera Software
;	Corvallis, Oregon 97330
;
;---------------------------------------
;This routine gets a block name from either 
; string input from the keyboard or a PICKED block
;
; ARGUMENTS : NONE
; RETURNS   : BLOCK NAME string
; FUNCTIONS : PKBLKNM
;
(defun ASKBNM ()
 (setq BNMIN nil)
 (while (not BNMIN)
 (if BNM
    (setq BPRMT (strcat "\nEnter the name of the block or hit P to pick an example :<" BNM ">: "))
    (setq BPRMT "\nEnter the name of the block or hit P to pick an example : ")
 );end if
 (setq BNMin (getstring BPRMT))
 (cond
	((= (strcase BNMIN) "P") (PKBLKNM));use this routine to "PICK" a block
	((= BNMIN "") BNM);use the default (previous block)
	(T (setq BLNM BNMIN));use a new block
 );end cond

    (if BLNM
       (if (tblsearch "block" BLNM); verify that block is part of drawing 
          BLNM
          (progn
	      (prompt (strcat "\n*** ERROR ! No block with the name <" BLNM "> exists in this drawing !"))
	      (setq BNM BNMIN BNMIN nil)
	  );end progn
       );end if
    );end if
 );end while
);end defun ASKBNM==============================

;
;------------------GETBLKS-------------
;
;This routine obtains a set of Blocks insertions
;
;ARGUMENTS :	NONE
;RETURNS   :	selection set of blocks
;FUNCTIONS :	PICKSET
;		ALLSET
(defun GETBLKS ()
  (if (and BSET (= OLDBLK BNM))
      (progn     
	(setq SPRMT (strcat "\nDo you wish to Select blocks, use Previous, or use All " BNM " blocks [S,P,A] <P> ? "))
	(initget "Select Previous All")
	(setq GETHOW (getkword SPRMT))
	(cond
	   ((= GETHOW "Select") (PICKSET BNM); get blocks by picking
	   )
	   ((= GETHOW "All") (ALLSET BNM); get all blocks with the name BNM
	   )
	);end cond - otherwise use the same set of blocks.
     );end progn
     (progn
	(setq SPRMT (strcat "\nDo you wish to Select blocks or use All " BNM " blocks [S,A] <A> : "))
	(initget "Select All")
	(setq GETHOW (getkword SPRMT))
	(cond
	   ((= GETHOW "Select") (PICKSET BNM); get blocks by picking
	   )
	   (( = GETHOW "All") (ALLSET BNM); get all blocks with the name BNM
	   )
	   ((= GETHOW nil)(ALLSET BNM); get all blocks with the name BNM
	   )
	);end cond - otherwise use the same set of blocks.
    );end progn
  );end if
);end defun GETBLKS==============================
;
;------------------GETSET--------------
;
;This routine collects a selection set of entities
;
;ARGUMENTS: a "FILTER" list as one argument
;RETURNS :a selection set called SS
;-----------------------
(defun GETSET (FLT)
	(setq SS (ssget FLT))
);end defun GETSET
;================================================
;
;------------------FOREAL--------------
;Verifies the blockname as an valid entityin the drawing database.
;
;ARGUMENTS :	block name (string)
;RETURNS   :	BOOLEAN value - nil or not nil
;
;
(defun FOREAL (WHAT)
  (if WHAT  (tblsearch "block" WHAT)); verify that block is part of drawing 
);end defun FOREAL===============================
;
;
;------------------PICKSET-------------
;
;PICKSET
; CALDERA SOFTWARE 11-22-1992
; r j zimmer
;
;This routine develops a selection set of inserts,
; based on : 1) a selections set of entities "picked"
;	     2) filtered out with "insert" and the provided blockname
;
(defun PICKSET (BNM)
 (setq FLT (list (cons 0 "insert") (cons 2 BNM))
       BSET (GETSET FLT)
 );end setq
);end defun PICKSET **********
;================================================

;------------------PKBLKNM-------------
;
;this routine extracts the "insert" block name 
; from a PICKED entity
;ARGUMENTS:	NONE
;RETURNS:	BLOCKNAME (AS A STRING) OR "NIL" 
;
(defun PKBLKNM ()
  (setq BLNM nil BENT nil)
  (while (not BENT)
	(setq BENT (entsel "\nPick BLOCK"))
 	(if BENT
	   (if  (or 
		  (not (= "INSERT" (PLUCK 0 (entdat BENT))))
	  	  (= "*" (substr (PLUCK 2 (entdat BENT)) 1 1));exclude HATCH blocks
		);end or
	      (progn
		(prompt "\n Entity selected was not a BLOCK ! Try again...")
		(setq BENT nil)
	      );end progn
     	      (setq BLNM (PLUCK 2 (entdat BENT)))
 	   );end if
	   (prompt "\nOOPS! You missed. Try again. ")
	);end if
  );end while
  (if BLNM (prompt (strcat "\n Using block : " BLNM)))
  BLNM
 );end defun PKBLKNM=============================
;

;
;------------------SCALEM------------
; This routine SCALES the provided entity or object about it's insertion point.
; 
; ARGUMENTS : 	entity
;		basepoint
;		scale factor
; RETURNS : 	nil
;
(defun SCALEM (IT)
 (setq SCLR (/ SF (pluck 41 IT)); divide destination scale factor
				; by the entity's current scale factor to
				; obtain a scale ratio
       BP (pluck 10 IT)
       ENT (pluck -1 IT)
 );end setq
 (command "scale" ENT "" BP SCLR)
 (princ ".")			;to show user something is happening
)
;end defun SCALEM ===============================
;
;------------------STEPTHRU------------
;
;STEPTHRU .lsp
; r j zimmer
;by Caldera Software 10-22-92
;
; This routine steps through a selection set,
; examining each entity one at a time.
; It allows the function that called it
; to operate on it in any number of ways,
; like checking for the presence of an entity.
;
; ARGUMENTS: the name of a selection set &
;	     a function to perform
; RETURNS: the entity data list ?
;--------------------------------------------------
(defun STEPTHRU (SS DOTHIS /)
 (setq LEN (sslength SS) CNT 0)
 (while (< CNT LEN)
	(setq EDAT (ENTDATA SS CNT))
	(dothis EDAT)
        (setq CNT (+ 1 CNT))
 );end while
);end defun STEPTHRU=============================
;
(prompt "\n\tCopyright Caldera Software April 16, 1993, Corvallis, Oregon USA. ")
;
;
;-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
;
;------------------CH2LA-------------
;
; by CALDERA SOFTWARE, February 1,1993
; 
; This routine the layer of a set of entities
;
; Functions called:	
(defun CH2LA ()
    (setq TOLA (ISLAYR))
    (COMMAND "CHPROP" "P" "" "LA" TOLA "")
);end defun CH2LA
;
;These are the operations that perform the 
; real work of the b-a_fix program.
;
;
;
;
;
;------------------SCALEBLK-------------
;
; by CALDERA SOFTWARE, November 22, 1992
; 
; This routine scales blocks about their
; insertion points, using a DESTINATION scale.
;
; It operates only on entities in MODELSPACE
; Functions called:	ASKBNM
;			FOREAL
;			PICKSET
;			ALLSET
;			STEPTHRU
;			SCALEM
;			
;--------------------------------------
(defun c:SCALEBLK ()
 (if BNM
  (if (FOREAL BNM); verify that block is part of drawing 
      (progn
	 (initget (+ 1 2 4))
	 (setq SF (getreal "\n Enter scale factor to set ALL the selected blocks to : "))
         (prompt "\n\t Setting TILEMODE to 1 & Zooming to extents. Please wait.\n")
         (command "TILEMODE" "1")
         (command "zoom" "e")
	 (if BSET (STEPTHRU BSET SCALEM)(setq CNT nil))
	 (if CNT
		(prompt (strcat "\n\t" (itoa CNT) " " BNM " blocks  modified to a " (rtos SF 2 2) " scale factor."))
		(princ "\nERROR ERROR -> NO blocks were scaled!")
	 );end if
	(command "ZOOM" "P")
	(princ)
      );end progn
      (prompt (strcat "\n No block with the name <" BNM "> exists in this drawing ! \n Program aborted."))
  );end if
  (prompt "\n Nothing was selected! Program terminated.")
 );end if
);end defun SCALEBLK ****;---------------------------------------
;;
;------------------SHFTBLK-------------
;
; by CALDERA SOFTWARE, February 15, 1993
; 
; This routine SHIFTS blocks about their
; insertion points, using a relative specified delta x & delta y.
;
; It operates only on entities in MODELSPACE
; Functions called:	ASKBNM
;			FOREAL
;			PICKSET
;			ALLSET
;			STEPTHRU
;			SHFTEM
;			
;--------------------------------------
(defun SHFTBLK ()
 (if BNM
  (if (FOREAL BNM); verify that block is part of drawing 
      (progn
	 (initget (+ 1))
	 (setq dX (getreal "\n Enter delta X to shift ALL the selected blocks : ")
	       dY (getreal "\n Enter delta Y to shift ALL the selected blocks <dX=DY>: ")	
	)
	   (if (= dY nil)(setq dY dX)); dX=DY
         (prompt "\n\t Setting TILEMODE to 1 & Zooming to extents. Please wait.\n")
;         (command "TILEMODE" "1")
;         (command "zoom" "e")
	 (if BSET (STEPTHRU BSET SHFTEM)(setq CNT nil))
	 (if CNT
		(prompt (strcat "\n\t" (itoa CNT) " " BNM " blocks  modified to a " (rtos SF 2 2) " scale factor."))
		(princ "\nERROR ERROR -> NO blocks were scaled!")
	 );end if
	(command "ZOOM" "E")
	(princ)
      );end progn
      (prompt (strcat "\n No block with the name <" BNM "> exists in this drawing ! \n Program aborted."))
  );end if
  (prompt "\n Nothing was selected! Program terminated.")
 );end if
);end defun SHFTBLK ****;---------------------------------------
;
;
;------------------shftem------------
; This routine shifts the provided entity or object from it's insertion point.
; 
; ARGUMENTS : 	entity
;		basepoint
;		scale factor
; RETURNS : 	nil
;
(defun SHFTEM (EDT)
 (setq
       DXY  (list DX DY)
       ENT (pluck -1 EDT)	;get entity data
 );end setq
 (command "MOVE" ENT "" DXY "");do the shift.
);end defun shftem ==================

;--------------------------------------

;------------------ROTBLK-------------
;
; by CALDERA SOFTWARE, November 22, 1992
; 
; This routine ROTATEs blocks about their
; insertion points, using a DESTINATION ROTATion angle.
;
; It operates only on entities in MODELSPACE
; Functions called:	ASKBNM
;			FOREAL
;			PICKSET
;			ALLSET
;			STEPTHRU
;			ROTATEM
;			
;--------------------------------------
(defun ROTBLK ()
 (if BNM
  (if (FOREAL BNM); verify that block is part of drawing 
      (progn
	 (initget (+ 1))
	 (setq RA (angtof
		    (getstring "\n Enter INSERTION angle to set ALL the selected blocks to : ")
		  );angtof
	 );end setq
         (prompt "\n\t Setting TILEMODE to 1 & Zooming to extents. Please wait.\n")
         (command "TILEMODE" "1")
         (command "zoom" "e")
	 (if BSET (STEPTHRU BSET ROTATEM)(setq CNT nil))
	 (if CNT
		(prompt (strcat "\n\t" (itoa CNT) " " BNM " blocks  rotated to a " (angtos RA) " degree angle."))
		(princ "\nERROR ERROR -> NO blocks were ROTATEd!")
	 );end if
	(princ)
      );end progn
      (prompt (strcat "\n No block with the name <" BNM "> exists in this drawing ! \n Program aborted."))
  );end if
  (prompt "\n Nothing was selected! Program terminated.")
 );end if
);end defun ROTBLK ****;---------------------------------------;





;------------------ROTATEM------------
; This routine SCALES the provided entity or object about it's insertion point.
; 
; ARGUMENTS : 	entity
;		basepoint
;		scale factor
; RETURNS : 	nil
;
(defun ROTATEM (IT)
 (setq ROTA (RTD (- RA (pluck 50 IT)));subtract destination rotation angle
				 ; by the entity's current rotation angle to
				 ; obtain a rotation angle difference
       BP (pluck 10 IT)
       ENT (pluck -1 IT)
 );end setq
 (command "rotate" ENT "" BP ROTA)
 (princ ".")			;to show user something is happening
)
;end defun ROTATEM ==================
;
;
;------------------bSUBOPT-------------
; block SUB OPTIONS
;
; this module collects more SUBoptions based on previous choices.
; 
;it takes a STRING as an argument and prompts for the block name
; it returns a new value for the BLOCK insertion name:
; & the modification value.
;
; if the block is not a valid insert an error message is echoed
; & the routine returns nil
; 
(defun BSUBOPT (Bin)
 (if (FOREAL BLK)
    (progn 
      (cond
	((= BIN "Scale")
	   (setq BVAL (getreal "Enter scale factor (multiplier) for these blocks : "))
	)
	((= BIN "Layer")
	   (setq BVAL (getstring \n"Enter new LAYER for these blocks : "))
	)
	((= BIN "sHift")
	   (setq BVAL (getdist "Enter or show amount to SHIFT these blocks (dX,dY,dZ) : "))
	)
	((= BIN "Rotation")
	   (setq BVAL (getangle "Enter ROTATION for these blocks : "))
	)
      );end cond
    );end progn
    (error1)
 );end if
);end defun BsubOPT
;
;
;------------------BOPTS---------------
;
;BOPTS
;BLOCK options
; This routine aquires input from the user to
;  inform the program what type of operation to
;  perform.
;
; It takes no arguments
; It returns the value (string) of the option selected :
;			"S": scale;
;			"L": layer;
;			"R": rotate;
;			"H": shift
(defun BOPTS ()
	(if (not bPREV) (setq bPREV " "))
	(initget "S L R B X")
	(prompt "\nSelect BLOCK editing option :")
	(prompt (strcat "\n\t Scale, Layer, Rotation, suBstitute or eXit: <" bPREV ">  "))
	(setq Bopt (getkword))
	(if BOPT (setq bPREV BOPT) (setq BOPT BPREV))
	(cond
	   ((= "S" BOPT) (c:SCALEBLK))
	   ((= "L" BOPT) (CH2LA))
	   ((= "R" BOPT) (ROTBLK))
	   ((= "B" BOPT) (NEWBLK))
	   ((= "Q" BOPT) (setq DONE "T"))
	);end cond
);end defun Bopts
;--------------------------------------
;======================================
;SWAPBLKS.LSP, copyright by Caldera Software, April 14, 1993
;			    r j zimmer
;			    Corvallis, Oregon 97330
;
;This routine will "swap" one block insertion for a new one.
;It allows the user to select a set of blocks to be suBstituted
;by a different block, using the original block's insertion point
;& a new or different insertion scale (x=y).
;
;ARGUMENTS:	Block entity name
;RETURNS:	nil
;
;	
;
(defun SWAPBLKS (BLOC)
   (if SAMSCL (setq SCL (pluck 41 BLOC))(setq SCL NWSCL))
   (if (= "Yes" SAMLA)(setq LAR (pluck 8 BLOC))(setq LAR NEWLA))
   (setq INPT (pluck 10 BLOC)
	 ROTANG (pluck 50 BLOC)
	 ENT (pluck -1 BLOC)
   );end setq
   (command "layer" "s" LAR "")
   (entdel ENT)
   (command "insert" NEWBNM INPT SCL SCL ROTANG)
   (princ ".");			show that something is happening.
   (setq SWPCNT (+ 1 SWPCNT))
);end defun SWAPBLKS-------------------

;NEWBLK.LSP, copyright by Caldera Software, April 14, 1993
;			  Corvallis, Oregon 97330
;
;This routine collects some information for the SWAPBLKS 
;routine.
;
;ARGUMENTS:	none
;RETURNS:	name of the replacement block
;		insertion scale for the replacement block
;		layer name for the new block to be inserted on
; It accesses the following modules:
;	ASKBNM
;
(defun NEWBLK ()
   (setq ATRQVAR (getvar "ATTREQ") SWPCNT 0 SAMSCL nil)
   (setvar "ATTREQ" 0)
   (prompt "\nSpecify the suBstitute (NEW) block's name: ")
   (setq NEWBNM (FNDBLK)
	 NEWSCL (strcase (getstring (strcat "\nEnter insertion SCALE for " NEWBNM " blocks, or S for same as " BNM " blocks:<S> ")))
   );end setq
   (if (or (= "" NEWSCL) (= "S" NEWSCL))(setq SAMSCL "T")(setq NWSCL (atof NEWSCL)))
   (initget "Yes No")
   (setq SAMLA (getkword "\nPlace NEW blocks on same layer as OLD blocks (Y,N)<Y>? "))
   (if (= SAMLA nil)(setq SAMLA "Yes"))
   (if (= "No" SAMLA)
	(ISLAYR)	
   );end if
         (prompt "\n\t Setting TILEMODE to 1 & Zooming to extents. Please wait.\n")
         (command "TILEMODE" "1")
         (command "zoom" "e")
	 (if BSET (STEPTHRU BSET SWAPBLKS)(setq SWPCNT nil))
	 (if SWPCNT
		(prompt (strcat "\n\t" (itoa SWPCNT) " " BNM " blocks changed to  " NEWBNM " blocks."))
		(princ "\nERROR ERROR -> NO blocks were scaled!")
	 );end if
	(command "ZOOM" "P")
   (setvar "ATTREQ" ATRQVAR);reset it
   (setq BNM nil);		reset this so that there is no longer a default
   (princ)
);end defun NEWBLK --------------------




;FNDBLK
;
;This routine verifies the name of a block definition,
;either internal or external.
;
(defun FNDBLK ()
  (setq FND nil)
  (while (not FND)
     (if BNM
        (setq BLKN (strcase (getstring (strcat "\n Enter name of SUBSTITION block <" BNM ">: "))))
        (setq BLKN (strcase (getstring "\n Enter name of SUBSTITION block: ")))
     );end if

     (if (= BLKN "")(setq BLKN BNM))
     (if (tblsearch "block" BLKN); see if block is part of drawing
	   (setq FND BLKN)
	   (setq FND (getfiled "Select SUBSTITUTION block" BLKN "dwg" 2))
     );end if
     (if (not FND)
	 (prompt (strcat "\n Block " BLKN " not found."))
	 (setq BNM FND)
     );end if
   );end while
);end defun fndblk
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;
(prompt "\nLoading OPTIONS routines for the Block-Attribute Editor. Please wait.. ")
;
;
;--------------------------------------------------
;OPTIONS lisp
; this routine offers the user a menu of options to chose from
; it returns the value selected
;
;--------------------------------------------------
;OPTIONS lisp
; this routine offers the user a menu of options to chose from
; it returns the value selected
;
(defun OPTIONS ()
   (while
	  (not (tblsearch "BLOCK"  (setq BNM (ASKBNM)))); get name of blocks to operate on
   );end while
      (GETBLKS); get blocks to modify

;   (if (and
;	  (tblsearch "BLOCK"  (ASKBNM)); get name of blocks to operate on
;	  (not (= "*" (substr BNM 1 1)));exclude HATCH blocks
;	);end and
;     (GETBLKS); get blocks to modify
;   );end if

   (setq LEN (sslength BSET))
   (princ (strcat "\nFound " (itoa len) " " BNM " blocks. "))
   (cond
	((= BorA "Block")
	 (setq OPT (BOPTS)); go get BLOCK sub-option
	)
	((= BorA "Attribute")
	   (if (HAS-ATTS BNM)
	      (progn	
		    (setq ATTR (ATTLIST) ATCNT 0 #ATTS 0)
		       (setq OPT (AOPTS));go get ATT sub-option;		|
		       (ASUBOPT OPT)			;		|
		       (STEPTHRU BSET AFIX)		;		|
		       (if ATCNT
		        (print (strcat "Finished editing " (itoa #ATTS) " " ATTR " attributes. "))
	      	       );end if
	      );end progn

	      (prompt "\n\t Block has no Attributes. ")

	   );end if
	)
	((= BorA nil)
		(setq OPT nil); return nil (to get out)
	)
	(t nil)
   );end cond
   (setq OLDBLK BNM)
   OPT
);end defun OPTIONS
;----------------------------------------------------------
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
(prompt "\nLoading general UTILITY module for the Block-Attribute Editor. Please wait.. ")
;--------------------------------------
;
(defun DTR (D) (/ (* D PI) 180.0))   ;
(defun RTD (R) (/ (* R 180.0) PI))   ;
;
(defun FLLD (NUM WHO)
   (cdr (assoc NUM WHO))
);end FLLD ******
;
;
(defun error1 (BNM)
   (princ "\n ERROR No attribute found with the name : " ATTR)
   (setq errlevel "T")
);end defun error1;==============================
;
;------------------ENTDAT--------------
;
;ARGUMENTS:     picked entity's name
;RETURNS the entity data of the supplied entity
;
(defun entdat (PICKED)
	(entget (car PICKED))
);end defun entdat===============================
;
;------------------ENTDATA-------------
;ENtdata.LSP
; extracts the entity name from a member of a selection set
; ARGUMENTS --> 1) THE SELECTION SET VARIABLE,
;               2) member's place in the set *
;               * remember that ss numbering begins with "0" set
; it extracts an entity from a selection
; it RETURNS the entity's data list
;
(defun entdata (SSV PL)
(setq   
   ENM (ssname SSV PL);get the name  of entity at place PL in 
		      ; the selection set SSV
   EDATA (entget ENM); get all the entity data
	);end setq
);end defun entdata ****
;================================================
;
;------------------PLUCK---------------
(defun PLUCK (NUM DAT)
	(cdr (assoc NUM DAT))
);end defun PLUCK;===============================
;
;-----------------ISLAYR--------------
;This routine checks for the existence of a LAYER
;if the layer does NOT exist it allows for its creation.
(defun ISLAYR ()
   (setq GUDLYR nil)
      (WHILE (not GUDLYR)
	(if (not
	(tblsearch "layer" (setq TOLA (getstring "\n Enter destination layer : "))))
	   (progn
	 	(initget 1 "Yes No")
		 (if (= "Yes" (getkword "\nLayer does not exist!!\nDo you want to create it? "))
		   (progn
		    (prompt (strcat "\nCreating layer " TOLA))
		    (command "layer" "n" TOLA "")
		    (setq GUDLYR "T")
		   );end progn
		 );end if
	   );end progn
	   (setq GUDLYR "T")
	);end if
      );end while
TOLA
);end defun ISLAYR=============================
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    (princ "\nType BLOKPOWR to begin\n")